#include "stdafx.h"
#include "FolderDialog.hpp"
#include "Utility.hpp"

namespace Lmt {
namespace O2Bms {
	FolderDialog::FolderDialog() {
		m_parent = NULL;
		m_title = L"";
		m_initialDir = L"";
		m_selectedDir = L"";
	}

	void FolderDialog::SetParent( HWND parent ) {
		m_parent = parent;
	}

	void FolderDialog::SetTitle( const wstring &title ) {
		m_title = title;
	}

	void FolderDialog::SetInitialDir( const wstring &directory ) {
		m_initialDir = directory;
	}

	wstring FolderDialog::GetSelectedDirectory() const {
		return m_selectedDir;
	}

	bool FolderDialog::Select() {
		BROWSEINFO bi;
		LPITEMIDLIST pidl = NULL;
		LPMALLOC pmalloc = NULL;
		wchar_t buffer[MAX_PATH];

		buffer[0] = '\0';

		// Shell ̕W̃AP[^擾
		if (FAILED( ::SHGetMalloc( &pmalloc ) )) {
			return false;
		}

		// BROWSEINFO \̂𖄂߂
		memset( &bi, 0, sizeof(bi) );
		bi.hwndOwner = m_parent;
		bi.pidlRoot = 0;
		bi.pszDisplayName = 0;
		bi.lpszTitle = m_title.c_str();
		bi.ulFlags = BIF_NEWDIALOGSTYLE | BIF_RETURNONLYFSDIRS;
		bi.lpfn = FolderDialog::BrowseCallbackProc;
		bi.lParam = reinterpret_cast<LPARAM>( this );

		// tH_̎Qƃ_CAO{bNX̕\
		if ((pidl = ::SHBrowseForFolder(&bi))) {
			::SHGetPathFromIDList( pidl, buffer );
			pmalloc->Free(pidl);
			pmalloc->Release();
			m_selectedDir = buffer;
			return true;
		}
		else {
			pmalloc->Release();
			return false;
		}
	}

	int CALLBACK FolderDialog::BrowseCallbackProc( HWND hwnd,UINT msg, LPARAM lp1, LPARAM lp2 ) {
		FolderDialog *pthis = reinterpret_cast<FolderDialog*>( lp2 );

		switch (msg) {
			case BFFM_INITIALIZED:
				::SendMessage( hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)pthis->m_initialDir.c_str() );
				break;
			default:
				break;
		}
		return 0;
	}
}
}
