#pragma once
#include "NoteValue.hpp"

namespace Lmt {
namespace O2Bms {
	class O2JamNoteValues {
		typedef vector<NoteValue> ValueArray;
		ValueArray m_values;
		int m_channel;
	public:
		O2JamNoteValues( int channel );
		O2JamNoteValues( int channel, const NoteValue *pvalue, int count );
		int GetChannel() const;
		int GetResolution() const;
		NoteValue GetValue( int index ) const;
		void Add( NoteValue value );
		void Add( const NoteValue *pvalue, int count );
		void Clear();
		bool Optimize();
		bool Expand( int ratio );
	private:
		void Initialize( int channel, const NoteValue *pvalue, int count );
	};
}
}
