#include "stdafx.h"
#include "VorbisSoundConverter.hpp"
#include "Utility.hpp"
//2007/6/10 1.04----->
#include "PcmConverter.hpp"
//<-------------------

namespace Lmt {
namespace O2Bms {
	//2007/6/10 1.04----->
	VorbisSoundConverter::VorbisSoundConverter( int samples, int bits ) {
		m_samples = samples;
		m_bits = bits;
		m_original = (m_samples == -1 && m_bits == -1);
	}
	//<-------------------

	//
	//߂񂱂̃Ro[^16rbgp@|c
	//
	bool VorbisSoundConverter::Convert( MusicPackageStream *input, const wstring &output ) {
		//2007/6/7 1.04----->
//		fstream fs( Utility::WStringToString( output ).c_str(), ios::out | ios::binary );
//		int readLength;
//		char buffer[4096];
//		
//		if (fs.is_open() == false) {
//			return false;
//		}
//		
//		//Ro[^𖼏Ă邭ɃRo[gȂ񂼁A[Ƃ₵Ȃ̃Ro[^(Ɂ`)
//		//̃f[^VorbisL蓾ȂAϊKvȂ
//		while ((readLength = input->Read( buffer, sizeof(buffer) )) > 0) {
//			fs.write( buffer, readLength );
//			if (fs.fail() == true) {
//				return false;
//			}
//		}
//
//		return true;
		//<------------------
		//2007/6/7 1.04----->
		fstream fs;
		OggVorbis_File vf;
		vorbis_info *pviIn;
		vorbis_info viOut;
		char **pcomments;
		vector<string> comments;
		ov_callbacks cbs = { OvReadCB, OvSeekCB, OvCloseCB, OvTellCB };
		bool ovOpen = false;
		bool encInit = false;
		bool result = false;

		ogg_stream_state os; /* take physical pages, weld into a logical stream of packets */
		ogg_page         og; /* one Ogg bitstream page.  Vorbis packets are inside */
		ogg_packet       op; /* one raw packet of data for decode */
		vorbis_comment   vc; /* struct that stores all the user comments */
		vorbis_dsp_state vd; /* central working state for the packet->PCM decoder */
		vorbis_block     vb; /* local working space for packet->PCM decode */

		PcmConverter pcmConv;
		int bytes;
		int channels;
		int srcUsed;
		int destUsed;
		float baseQuality;
		bool endOfRead = false;
		const int bufLength = 1024;
		char readbuffer[bufLength * 4];
		char pcmbuffer[bufLength * 32];

		//Vorbist@CJ
		ovOpen = (::ov_open_callbacks( input, &vf, NULL, 0, cbs ) == 0);
		if (ovOpen == false) {
			goto EndMethod;
		}
		if (!::ov_seekable( &vf )) {
			goto EndMethod;
		}

		pviIn = ::ov_info( &vf, -1 );

		//Rg̏
		pcomments = ::ov_comment( &vf, -1 )->user_comments;
		for (; *pcomments; pcomments++) {
			comments.push_back( string( *pcomments ) );
		}

		//PCMRo[^
		if (m_original == true) {
			if (pcmConv.Initialize( pviIn->rate, 16, pviIn->channels, pviIn->rate, 16, pviIn->channels ) == false) {
				goto EndMethod;
			}
		}
		else {
			if (pcmConv.Initialize( pviIn->rate, 16, pviIn->channels, m_samples, m_bits, pviIn->channels ) == false) {
				goto EndMethod;
			}
		}

		//base_quality
		switch (pcmConv.GetOutputSamples()) {
			case 8000:
			case 11025:
			case 12000:
				baseQuality = 0.1f;
				break;
			case 16000:
			case 22050:
			case 24000:
				baseQuality = 0.2f;
				break;
			case 32000:
			case 44100:
			case 48000:
				baseQuality = 0.4f;
				break;
			case 88200:
			case 96000:
				baseQuality = 0.8f;
				break;
			default:
				baseQuality = 0.5f;
				break;
		}

		//GR[_
		::vorbis_info_init( &viOut );
		if (::vorbis_encode_init_vbr( &viOut, pcmConv.GetOutputChannels(), pcmConv.GetOutputSamples(), baseQuality )) {
			goto EndMethod;
		}

		//Rgǉ
		::vorbis_comment_init( &vc );
		::vorbis_comment_add_tag( &vc, "ENCODER", "O2BMS-OggVorbisEncoder" );
		for (vector<string>::iterator it = comments.begin(); it != comments.end(); it++) {
			vorbis_comment_add( &vc, const_cast<char*>( it->c_str() ) );
		}

		//set up the analysis state and auxiliary encoding storage
		::vorbis_analysis_init( &vd, &viOut );
		::vorbis_block_init( &vd, &vb );
			
		//set up our packet->stream encoder
		//pick a random serial number; that way we can more likely build
		//chained streams just by concatenation
		srand( time(NULL) );
		::ogg_stream_init( &os, rand() );
		encInit = true;

		//o̓t@CJ
		fs.open( Utility::WStringToString( output ).c_str(), ios::out | ios::binary );
		if (fs.is_open() == false) {
			goto EndMethod;
		}

		//wb_[o
		{
			ogg_packet header;
			ogg_packet header_comm;
			ogg_packet header_code;

			::vorbis_analysis_headerout( &vd, &vc, &header, &header_comm, &header_code );
			::ogg_stream_packetin( &os, &header ); /* automatically placed in its own page */
			::ogg_stream_packetin( &os, &header_comm );
			::ogg_stream_packetin( &os, &header_code );

			//This ensures the actual audio data will start on a new page, as per spec
			while (true) {
				if (::ogg_stream_flush( &os, &og ) == 0) {
					break;
				}
				fs.write( reinterpret_cast<char*>( og.header ), og.header_len );
				fs.write( reinterpret_cast<char*>( og.body ), og.body_len );
			}
		}

		//f[^̏ݏ
		while( endOfRead == false ){
			bytes = ::ov_read( &vf, readbuffer, bufLength * 4, 0, 2, 1, NULL );

			if (bytes == 0) {
				//end of file.  this can be done implicitly in the mainline,
				//but it's easier to see here in non-clever fashion.
				//Tell the library we're at end of stream so that it can handle
				//the last frame and mark end of stream in the output properly
				vorbis_analysis_wrote( &vd, 0 );
			}
			else{
				if (pcmConv.Convert( readbuffer, bytes, &srcUsed, pcmbuffer, sizeof(pcmbuffer), &destUsed ) == false) {
					goto EndMethod;
				}
#ifdef _DEBUG
				if (bytes != srcUsed) {
					int a = 1;
				}
#endif

				//data to encode
				//expose the buffer to submit data
				float **buffer = ::vorbis_analysis_buffer( &vd, bufLength * 8 );

				//uninterleave samples
//				for(int i = 0; i < bytes / (pviIn->channels * 2); i++){
//					buffer[0][i] = ((readbuffer[i * 4 + 1] << 8) | (0x00ff & (int)readbuffer[i *4 ])) / 32768.f;
//					buffer[1][i] = ((readbuffer[i * 4 + 3] << 8) | (0x00ff & (int)readbuffer[i *4 + 2])) / 32768.f;
//				}
				channels = pviIn->channels;
				for (int i = 0; i < destUsed / (channels * 2); i++) {
					for (int n = 0; n < channels; n++) {
						buffer[n][i] = (
							(pcmbuffer[i * (channels * 2) + n * 2 + 1] << 8) |
							(0x00ff & (int)pcmbuffer[i * (channels * 2) + n * 2])
						) / 32768.f;
					}
				}

				//tell the library how much we actually submitted
				vorbis_analysis_wrote( &vd, i );
			}

			//vorbis does some data preanalysis, then divvies up blocks for
			//more involved (potentially parallel) processing.  Get a single
			//block for encoding now
			while( ::vorbis_analysis_blockout( &vd, &vb ) ==1 ) {
				//analysis, assume we want to use bitrate management
				::vorbis_analysis( &vb, NULL );
				::vorbis_bitrate_addblock( &vb );

				while( ::vorbis_bitrate_flushpacket( &vd, &op ) ){
					//weld the packet into the bitstream
					::ogg_stream_packetin( &os, &op );

					//write out pages (if any)
					while( endOfRead == false ) {
						if (::ogg_stream_pageout( &os, &og ) == 0) {
							break;
						}
						fs.write( reinterpret_cast<char*>( og.header ), og.header_len );
						fs.write( reinterpret_cast<char*>( og.body ), og.body_len );

						//this could be set above, but for illustrative purposes, I do
						//it here (to show that vorbis does know where the stream ends)
						if (::ogg_page_eos( &og )) {
							endOfRead = true;
							break;
						}
					}
				}
			}
		}

		//I
		result = true;

	EndMethod:
		//I
		if (ovOpen == true) {
			::ov_clear( &vf );
		}
		if (encInit == true) {
			::ogg_stream_clear( &os );
			::vorbis_block_clear( &vb );
			::vorbis_dsp_clear( &vd );
			::vorbis_comment_clear( &vc );
			::vorbis_info_clear( &viOut );
		}
		if (fs.is_open() == true) {
			fs.close();
		}

		return result;
		//<------------------
	}
}
}
