#include "stdafx.h"
#include "WaveSoundConverter.hpp"
#include "Utility.hpp"
//2007/6/9 1.04----->
#include "PcmConverter.hpp"
//<------------------

namespace Lmt {
namespace O2Bms {
	//2007/6/9 1.04----->
//	static size_t read_func( void *ptr, size_t size, size_t nmemb, void *datasource ) {
//		MusicPackageStream *pstream = reinterpret_cast<MusicPackageStream*>( datasource );
//		return pstream->Read( ptr, static_cast<int>( size * nmemb ) );
//	}
//
//	static int seek_func( void *datasource, ogg_int64_t offset, int whence ) {
//		MusicPackageStream *pstream = reinterpret_cast<MusicPackageStream*>( datasource );
//		switch (whence) {
//			case SEEK_SET: return pstream->Seek( static_cast<int>( offset ), SeekFromBegin );
//			case SEEK_END: return pstream->Seek( static_cast<int>( offset ), SeekFromEnd );
//			case SEEK_CUR: return pstream->Seek( static_cast<int>( offset ), SeekFromCurrent );
//			default: return -1;
//		}
//	}
//
//	static int close_func( void *datasource ) {
//		MusicPackageStream *pstream = reinterpret_cast<MusicPackageStream*>( datasource );
//		return 0;
//	}
//
//	static long tell_func( void *datasource ) {
//		MusicPackageStream *pstream = reinterpret_cast<MusicPackageStream*>( datasource );
//		return pstream->Tell();
//	}
	//<------------------
	
	WaveSoundConverter::WaveSoundConverter( int samples, int bits ) {
		m_samples = samples;
		m_bits = bits;
		//2007/6/9 1.04----->
		m_original = (m_samples == -1 && m_bits == -1);
		//<------------------
	}
	
	bool WaveSoundConverter::Convert( MusicPackageStream *input, const wstring &output ) {
		//2007/6/9 1.04----->
//		HACMSTREAM acmStream = NULL;
//		ACMSTREAMHEADER acmHeader;
//		WAVEFORMATEX wfIn;
//		WAVEFORMATEX wfOut;
		PcmConverter pcmConv;
		//<------------------
		int realRead;
		int srcIndex;
		int totalLength;
		//2007/6/9 1.04----->
//		bool headerPrepare = false;
		//<------------------

		//2007/6/9 1.04----->
//		ov_callbacks cbs = { read_func, seek_func, close_func, tell_func };
		ov_callbacks cbs = { OvReadCB, OvSeekCB, OvCloseCB, OvTellCB };
		//<------------------
		OggVorbis_File vf;
		vorbis_info vi;
		bool ovInit = false;
		
		fstream fsOut;

		//2007/6/9 1.04----->
		int srcUsed;
		int destUsed;
		//<------------------
		char bufferIn[512];
		char bufferOut[512];
		
		//VorbisfR[h̏
		if (::ov_open_callbacks( input, &vf, NULL, 0, cbs ) < 0) {
			goto ErrorMethod;
		}
		else if (!::ov_seekable( &vf )) {
			::ov_clear( &vf );
			goto ErrorMethod;
		}
		else {
			vi = *::ov_info( &vf, -1 );
			ovInit = true;
		}

		//2007/6/9 1.04----->
//		//̓tH[}bg
//		memset( &wfIn, 0, sizeof(wfIn) );
//		wfIn.wFormatTag = WAVE_FORMAT_PCM;
//		wfIn.nChannels = vi.channels;
//		wfIn.nSamplesPerSec = vi.rate;
//		wfIn.wBitsPerSample = 16;
//		wfIn.nBlockAlign = wfIn.nChannels * (wfIn.wBitsPerSample) / 8;
//		wfIn.nAvgBytesPerSec = wfIn.nBlockAlign * wfIn.nSamplesPerSec;
//		wfIn.cbSize = 0;
//		
//		//o̓tH[}bg
//		memset( &wfOut, 0, sizeof(wfOut) );
//		wfOut.wFormatTag = WAVE_FORMAT_PCM;
//		wfOut.nChannels = vi.channels;
//		wfOut.nSamplesPerSec = m_samples;
//		wfOut.wBitsPerSample = m_bits;
//		wfOut.nBlockAlign = wfOut.nChannels * (wfOut.wBitsPerSample) / 8;
//		wfOut.nAvgBytesPerSec = wfOut.nBlockAlign * wfOut.nSamplesPerSec;
//		wfOut.cbSize = 0;
//		
//		//ACMXg[
//		if (::acmStreamOpen( &acmStream, NULL, &wfIn, &wfOut, NULL, NULL, NULL, 0 ) != 0) {
//			goto ErrorMethod;
//		}
		if (m_original == true) {
			if (pcmConv.Initialize( vi.rate, 16, vi.channels, vi.rate, 16, vi.channels ) == false) {
				goto ErrorMethod;
			}
		}
		else {
			if (pcmConv.Initialize( vi.rate, 16, vi.channels, m_samples, m_bits, vi.channels ) == false) {
				goto ErrorMethod;
			}
		}
		//<------------------

		//o̓t@CJ
		fsOut.open( Utility::WStringToString( output ).c_str(), ios::out | ios::binary );
		if (fsOut.is_open() == false) {
			goto ErrorMethod;
		}
		
		//WAVEwb_[̃_~[o
		if (WaveSoundConverter::WriteDummyHeader( fsOut ) == false) {
			goto ErrorMethod;
		}
		
		//fR[h`[gϊ`o
		while ((realRead = ::ov_read( &vf, bufferIn, sizeof(bufferIn), 0, 2, 1, NULL )) > 0) {
			srcIndex = 0;
			while (srcIndex < realRead) {
				//2007/6/9 1.04----->
//				//ACMwb_[̏
//				memset( &acmHeader, 0, sizeof(acmHeader) );
//				acmHeader.cbStruct = sizeof(acmHeader);
//				acmHeader.pbSrc = reinterpret_cast<LPBYTE>( bufferIn + srcIndex );
//				acmHeader.cbSrcLength = realRead - srcIndex;
//				acmHeader.pbDst = reinterpret_cast<LPBYTE>( bufferOut );
//				acmHeader.cbDstLength = sizeof(bufferOut);
//
//				//ϊ
//				if (::acmStreamPrepareHeader( acmStream, &acmHeader, 0 ) != 0) {
//					goto ErrorMethod;
//				}
//				if (::acmStreamConvert( acmStream, &acmHeader, ACM_STREAMCONVERTF_BLOCKALIGN ) != 0) {
//					::acmStreamUnprepareHeader( acmStream, &acmHeader, 0 );
//					goto ErrorMethod;
//				}
//				::acmStreamUnprepareHeader( acmStream, &acmHeader, 0 );
				if (pcmConv.Convert( bufferIn + srcIndex, realRead - srcIndex, &srcUsed, bufferOut, sizeof(bufferOut), &destUsed ) == false) {
					goto ErrorMethod;
				}
				//<------------------
				
				//ϊς݃f[^t@Cɏo
				//2007/6/9 1.04----->
//				fsOut.write( (char*)bufferOut, acmHeader.cbDstLengthUsed );
				fsOut.write( (char*)bufferOut, destUsed );
				//<------------------
				if (fsOut.fail() == true) {
					goto ErrorMethod;
				}
				
				//ϊJ[\߂
				//2007/6/9 1.04----->
//				srcIndex += acmHeader.cbSrcLengthUsed;
				srcIndex += srcUsed;
				//<------------------
			}
		}
		
		//2007/6/9 1.04----->
//		//ACMpς
//		::acmStreamClose( acmStream, 0 );
//		acmStream = NULL;
		//<------------------
		
		//Vorbispς
		::ov_clear( &vf );
		ovInit = false;

		//TCY0̃TEhoA߂0.05b炢͓˂ł
		totalLength = fsOut.tellg();
		totalLength -= sizeof(WaveFileHeader);
		if (totalLength <= 0) {
			//2007/6/9 1.04----->
//			if (WaveSoundConverter::AppendMute( fsOut, wfOut.wBitsPerSample, wfOut.nSamplesPerSec / 20 ) == false) {
			if (WaveSoundConverter::AppendMute( fsOut, pcmConv.GetOutputBits(), pcmConv.GetOutputSamples() / 20 ) == false) {
			//<------------------
				goto ErrorMethod;
			}
		}

		//ŏIIWAVEwb_[
		if (WaveSoundConverter::WriteHeaderFinal( fsOut, pcmConv.GetOutputWaveFormat() ) == false) {
			goto ErrorMethod;
		}

		//SI
		fsOut.close();
		return true;

		//G[
	ErrorMethod:
		//2007/6/9 1.04----->
//		if (acmStream != NULL) {
//			::acmStreamClose( acmStream, 0 );
//		}
		//<------------------
		if (ovInit == true) {
			::ov_clear( &vf );
		}
		return false;
	}

	bool WaveSoundConverter::CreateMuteSound( const wstring &path, int samples, int bits, int count ) {
		WAVEFORMATEX wf;
		fstream fs( Utility::WStringToString( path ).c_str(), ios::out | ios::binary );

		if (fs.is_open() == false) {
			return false;
		}

		memset( &wf, 0, sizeof(wf) );
		wf.wFormatTag = WAVE_FORMAT_PCM;
		wf.nChannels = 1;
		wf.nSamplesPerSec = samples;
		wf.wBitsPerSample = bits;
		wf.nBlockAlign = bits / 8;
		wf.nAvgBytesPerSec = wf.nBlockAlign * wf.nSamplesPerSec;
		wf.cbSize = 0;

		if (WaveSoundConverter::WriteDummyHeader( fs ) == false) {
			return false;
		}
		if (WaveSoundConverter::AppendMute( fs, bits, count ) == false) {
			return false;
		}
		if (WaveSoundConverter::WriteHeaderFinal( fs, wf ) == false) {
			return false;
		}

		return true;
	}

	bool WaveSoundConverter::WriteDummyHeader( fstream &fs ) {
		WaveFileHeader waveHeader;

		memset( &waveHeader, 0, sizeof(waveHeader) );
		fs.write( (char*)&waveHeader, sizeof(waveHeader) );
		if (fs.fail() == true) {
			return false;
		}

		return true;
	}

	bool WaveSoundConverter::WriteHeaderFinal( fstream &fs, const WAVEFORMATEX wfOut ) {
		WaveFileHeader waveHeader;

		memcpy( waveHeader.chunkRiff, "RIFF", 4 );
		memcpy( waveHeader.chunkWave, "WAVE", 4 );
		memcpy( waveHeader.chunkFmt, "fmt ", 4 );
		memcpy( waveHeader.chunkData, "data", 4 );
		waveHeader.length = fs.tellg();
		waveHeader.length -= 8;
		waveHeader.lengthFmt = 16;
		waveHeader.formatTag = wfOut.wFormatTag;
		waveHeader.channels = wfOut.nChannels;
		waveHeader.samplesPerSec = wfOut.nSamplesPerSec;
		waveHeader.blockAlign = wfOut.nBlockAlign;
		waveHeader.bitsPerSamples = wfOut.wBitsPerSample;
		waveHeader.avgBytesPerSec = wfOut.nAvgBytesPerSec;
		waveHeader.lengthData = fs.tellg();
		waveHeader.lengthData -= sizeof(waveHeader);
		fs.seekg( 0, ios::beg );
		fs.write( (char*)&waveHeader, sizeof(waveHeader) );
		if (fs.fail() == true) {
			return false;
		}

		return true;
	}

	bool WaveSoundConverter::AppendMute( fstream &fs, int bits, int count ) {
		int bytes = bits / 8;
		int remain = count * bits;
		int writeLength;
		char buffer[512];

		switch (bits) {
			case 8: memset( buffer, 0x80, sizeof(buffer) ); break;
			case 16: memset( buffer, 0x00, sizeof(buffer) ); break;
			default: return false;
		}

		while (remain > 0) {
			writeLength = min( sizeof(buffer), remain );
			fs.write( buffer, writeLength );
			if (fs.fail() == true) {
				return false;
			}
			remain -= writeLength;
		}

		return true;
	}
}
}
