#pragma once
#include "SoundConverter.hpp"

namespace Lmt {
namespace O2Bms {
	class WaveSoundConverter : public SoundConverter {
		int m_samples;
		int m_bits;
		//2007/6/9 1.04----->
		bool m_original;
		//<------------------
	private:
		struct WaveFileHeader {
			char chunkRiff[4];
			unsigned int length;
			char chunkWave[4];
			char chunkFmt[4];
			unsigned int lengthFmt;
			unsigned short formatTag;
			unsigned short channels;
			unsigned int samplesPerSec;
			unsigned int avgBytesPerSec;
			unsigned short blockAlign;
			unsigned short bitsPerSamples;
			char chunkData[4];
			unsigned int lengthData;
		};
	public:
		WaveSoundConverter( int samples, int bits );
		virtual bool Convert( MusicPackageStream *input, const wstring &output );
		static bool CreateMuteSound( const wstring &path, int samples, int bits, int count );
	private:
		static bool WriteDummyHeader( fstream &fs );
		static bool WriteHeaderFinal( fstream &fs, const WAVEFORMATEX wfOut );
		static bool AppendMute( fstream &fs, int bits, int count );
	};
}
}
